<?php
/*
//----------------------------------------------------------------------------
// Copyright (c) 2006-2011 Asymmetric Software - Innovation & Excellence
// Author: Mark Samios
// http://www.asymmetrics.com
// Admin: Nodes core class
// Loads/Saves node files, determines best paths among nodes, 
// using distances and vertices
// Supports loading and storing path files
// Multiple controls for shortest paths vs performance added
//----------------------------------------------------------------------------
// I-Metrics CMS
//----------------------------------------------------------------------------
// Script is intended to be used with:
// osCommerce, Open Source E-Commerce Solutions
// http://www.oscommerce.com
// Copyright (c) 2003 osCommerce
//----------------------------------------------------------------------------
// Released under the GNU General Public License
//----------------------------------------------------------------------------
*/

  // Merges 2 array from a given common key
  // The common key is the last key in the trail array and is also present in the lead_array
  // Will remove from lead array all elements till it finds the common key
  // It will then append the lead array into trail array
  function tep_array_splice_from_key($lead_array, $trail_array, $index) {

    end($trail_array);
    $k = key($trail_array);
    array_pop($trail_array);

    foreach($lead_array as $key => $value) {
      if( $key == $index ) break;
      unset($lead_array[$key]);
    }

    $trail_array += $lead_array;
    return $trail_array;
  }

  function tep_read_contents($filename, &$contents) {
    $result = false;
    $contents = '';

    if( !file_exists($filename) ) return $result;

    $size = filesize($filename);
    if( !$size ) return $result;

    $fp = @fopen($filename, 'r');
    if( !$fp ) return $result;

    $contents = fread($fp, $size);
    fclose($fp);
    $result = true;
    return $result;
  }

  function tep_write_contents($filename, $contents) {
    $result = false;
    $fp = @fopen($filename, 'w');
    if( $fp ) {
      $size = fwrite($fp, $contents);
      fclose($fp);
      $result = ($size > 0);
    }
    return $result;
  }

  require_once('nodes.php');

  $path = array(
    '1' => array('2' => 4, '5' => 9),
    '2' => array('1' => 4, '4' => 5, '3' => 3),
    '3' => array('2' => 3, '9' => 6, '10' => 4),
    '4' => array('2' => 5, '5' => 4, '9' => 5, '15' => 5),
    '5' => array('1' => 9, '6' => 5, '4' => 4),
    '6' => array('5' => 5, '15' => 4, '20' => 5),
    '7' => array('16' => 6, '20' => 6),
    '8' => array('15' => 5, '16' => 6),
    '9' => array('3' => 6, '4'=> 5, '12' => 6),
    '10' => array('3' => 4, '11' => 5),
    '11' => array('10' => 5, '12' => 6, '13' => 6, '14' => 4),
    '12' => array('9' => 6, '11' => 6, '19' => 4),
    '13' => array('11' => 6, '14' => 8),
    '14' => array('11' => 4, '13' => 8, '19' => 5),
    '15' => array('4' => 5, '6' => 4, '8' => 5),
    '16' => array('7' => 6, '8' => 6, '18' => 4),
    '17' => array('18' => 4, '19' => 6),
    '18' => array('16' => 4, '17' => 4),
    '19' => array('12' => 4, '14' => 5, '17' => 6),
    '20' => array('6' => 5, '7' => 6),
  );

  $verts = array(
    '1' => array('x' => 1, 'y' => 1, 'z' => 1),
    '2' => array('x' => 3, 'y' => 4, 'z' => 1),
    '3' => array('x' => 3, 'y' => 8, 'z' => 1),
    '4' => array('x' => 8, 'y' => 6, 'z' => 1),
    '5' => array('x' => 10, 'y' => 2, 'z' => 1),
    '6' => array('x' => 15, 'y' => 2, 'z' => 1),
    '7' => array('x' => 19, 'y' => 7, 'z' => 1),
    '8' => array('x' => 13, 'y' => 10, 'z' => 1),
    '9' => array('x' => 8, 'y' => 11, 'z' => 1),
    '10' => array('x' => 2, 'y' => 14, 'z' => 1),
    '11' => array('x' => 6, 'y' => 17, 'z' => 1),
    '12' => array('x' => 12, 'y' => 15, 'z' => 1),
    '13' => array('x' => 1, 'y' => 20, 'z' => 1),
    '14' => array('x' => 9, 'y' => 20, 'z' => 1),
    '15' => array('x' => 13, 'y' => 5, 'z' => 1),
    '16' => array('x' => 18, 'y' => 13, 'z' => 1),
    '17' => array('x' => 20, 'y' => 20, 'z' => 1),
    '18' => array('x' => 20, 'y' => 16, 'z' => 1),
    '19' => array('x' => 14, 'y' => 18, 'z' => 1),
    '20' => array('x' => 20, 'y' => 1, 'z' => 1),
  );

  echo '<pre>';
  //$cObject = new nodes('nodes.txt', '', 1);
  //$cObject = new nodes('', '', 1);
  $cObject = new nodes($path, $verts, 1);
  //nodes::create_random_nodes();
  //nodes::$nodes_array[444][55]=5;
  $cObject->reset();
  nodes::short_nodes();
  //$cObject->set_stack_depth(10);
  //$cObject->set_max_results(5);
  //$cObject->get_path(19,15);
  $cObject->get_path(3,8);

  echo $cObject->get_result_strings();
  echo $cObject->get_stats();
  //nodes::save_path_file('nodes.txt');
  echo '</pre>';
?>